﻿(function () {

    "use strict";

    angular.module("enrCircularProgressBarModule", [])
           .directive("enrCircularProgressBar", ["progressBarLibService", "d3Service", function (progressBarLibService, d3Service) {

               function link(scope, element) {
                   var progressBarElement = element[0];

                   // Draw circle
                   var circle = new progressBarLibService.Circle(progressBarElement, {
                       color: scope.displayColor,
                       strokeWidth: 6,
                       trailWidth: 6,
                       trailColor: "#e5e5e5",
                       text: { color: "#9b9b9b", value: " " } // value triggers creation of <p> element on which we can attach glyph below.
                   });

                   // Draw Check Glyph
                   if (scope.displayGlyph === "true")
                       d3Service.select(circle.text).attr("class", "progressbar-glyph zmdi zmdi-check-all");

                   // Draw progress bar fill
                   var deregisterWatch = scope.$watch("displayPercent", function (displayPercent) {

                       // Do nothing if no, or incomplete, data.
                       if (displayPercent === undefined)
                           return;

                       circle.set(displayPercent);

                       // If the progress level is never going to change, cancel watch.
                       if (scope.progressChanges !== "true")
                           deregisterWatch();
                   });
               }

               return {
                   scope: {
                       displayColor: "@",
                       displayPercent: "=",
                       displayGlyph: "@",
                       progressChanges: "@"
                   },
                   link: link,
                   restrict: "E"
               }
           }]);

}());
